From 750755e55771dca2674a6bd5a2a5a59b86f0d8f4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 01 2020 21:47:29 +0000
Subject: [PATCH 71/2232] Rename namespace to rust::inline cxxbridge01


---

diff --git a/demo-cxx/demo.cc b/demo-cxx/demo.cc
index 3900572..79340eb 100644
--- a/demo-cxx/demo.cc
+++ b/demo-cxx/demo.cc
@@ -9,7 +9,7 @@ ThingC::ThingC(std::string appname) : appname(std::move(appname)) {}
 
 ThingC::~ThingC() { std::cout << "done with ThingC" << std::endl; }
 
-std::unique_ptr<ThingC> make_demo(cxxbridge::Str appname) {
+std::unique_ptr<ThingC> make_demo(::rust::Str appname) {
   return std::unique_ptr<ThingC>(new ThingC(appname));
 }
 
diff --git a/demo-cxx/demo.h b/demo-cxx/demo.h
index d41ea7a..aa417c7 100644
--- a/demo-cxx/demo.h
+++ b/demo-cxx/demo.h
@@ -16,7 +16,7 @@ public:
 
 struct SharedThing;
 
-std::unique_ptr<ThingC> make_demo(cxxbridge::Str appname);
+std::unique_ptr<ThingC> make_demo(::rust::Str appname);
 const std::string &get_name(const ThingC &thing);
 void do_thing(SharedThing state);
 
diff --git a/gen/write.rs b/gen/write.rs
index 31eee36..a2c1b7a 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -21,21 +21,11 @@ pub(super) fn gen(namespace: Vec<String>, apis: &[Api], types: &Types, header: b
     write_includes(out, types);
     write_include_cxxbridge(out, types);
 
-    if !header {
-        out.next_section();
-        write_namespace_alias(out, types);
-    }
-
     out.next_section();
     for name in &namespace {
         writeln!(out, "namespace {} {{", name);
     }
 
-    if header {
-        out.next_section();
-        write_namespace_alias(out, types);
-    }
-
     out.next_section();
     for api in apis {
         match api {
@@ -125,7 +115,8 @@ fn write_include_cxxbridge(out: &mut OutFile, types: &Types) {
         }
     }
 
-    out.begin_block("namespace cxxbridge01");
+    out.begin_block("namespace rust");
+    out.begin_block("inline namespace cxxbridge01");
     if needs_rust_box {
         writeln!(out, "// #include \"cxxbridge.h\"");
         for line in include::get("CXXBRIDGE01_RUST_BOX").lines() {
@@ -135,20 +126,7 @@ fn write_include_cxxbridge(out: &mut OutFile, types: &Types) {
         }
     }
     out.end_block();
-}
-
-fn write_namespace_alias(out: &mut OutFile, types: &Types) {
-    let mut needs_namespace_alias = false;
-    for ty in types {
-        if let Type::RustBox(_) = ty {
-            needs_namespace_alias = true;
-            break;
-        }
-    }
-
-    if needs_namespace_alias {
-        writeln!(out, "namespace cxxbridge = cxxbridge01;");
-    }
+    out.end_block();
 }
 
 fn write_struct(out: &mut OutFile, strct: &Struct) {
@@ -365,7 +343,7 @@ fn write_extern_return_type(out: &mut OutFile, ty: &Option<Type>, types: &Types)
             write_type(out, &ty.inner);
             write!(out, " *");
         }
-        Some(Type::Str(_)) => write!(out, "::cxxbridge::Str::Repr "),
+        Some(Type::Str(_)) => write!(out, "::rust::Str::Repr "),
         Some(ty) if types.needs_indirect_abi(ty) => write!(out, "void "),
         _ => write_return_type(out, ty),
     }
@@ -377,7 +355,7 @@ fn write_extern_arg(out: &mut OutFile, arg: &Var, types: &Types) {
             write_type_space(out, &ty.inner);
             write!(out, "*");
         }
-        Type::Str(_) => write!(out, "::cxxbridge::Str::Repr "),
+        Type::Str(_) => write!(out, "::rust::Str::Repr "),
         _ => write_type_space(out, &arg.ty),
     }
     if types.needs_indirect_abi(&arg.ty) {
@@ -401,11 +379,11 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             Some(I64) => write!(out, "int64_t"),
             Some(Isize) => write!(out, "ssize_t"),
             Some(CxxString) => write!(out, "::std::string"),
-            Some(RustString) => write!(out, "::cxxbridge::String"),
+            Some(RustString) => write!(out, "::rust::String"),
             None => write!(out, "{}", ident),
         },
         Type::RustBox(ty) => {
-            write!(out, "::cxxbridge::Box<");
+            write!(out, "::rust::Box<");
             write_type(out, &ty.inner);
             write!(out, ">");
         }
@@ -422,7 +400,7 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             write!(out, " &");
         }
         Type::Str(_) => {
-            write!(out, "::cxxbridge::Str");
+            write!(out, "::rust::Str");
         }
     }
 }
@@ -458,7 +436,8 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
     }
     out.end_block();
 
-    out.begin_block("namespace cxxbridge01");
+    out.begin_block("namespace rust");
+    out.begin_block("inline namespace cxxbridge01");
     for ty in types {
         if let Type::RustBox(ty) = ty {
             if let Type::Ident(inner) = &ty.inner {
@@ -467,6 +446,7 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
         }
     }
     out.end_block();
+    out.end_block();
 }
 
 fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {
@@ -482,27 +462,27 @@ fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {
     writeln!(out, "#define CXXBRIDGE01_RUST_BOX_{}", instance);
     writeln!(
         out,
-        "void cxxbridge01$rust_box${}$uninit(::cxxbridge::Box<{}> *ptr) noexcept;",
+        "void cxxbridge01$rust_box${}$uninit(::rust::Box<{}> *ptr) noexcept;",
         instance, inner,
     );
     writeln!(
         out,
-        "void cxxbridge01$rust_box${}$set_raw(::cxxbridge::Box<{}> *ptr, {} *raw) noexcept;",
+        "void cxxbridge01$rust_box${}$set_raw(::rust::Box<{}> *ptr, {} *raw) noexcept;",
         instance, inner, inner
     );
     writeln!(
         out,
-        "void cxxbridge01$rust_box${}$drop(::cxxbridge::Box<{}> *ptr) noexcept;",
+        "void cxxbridge01$rust_box${}$drop(::rust::Box<{}> *ptr) noexcept;",
         instance, inner,
     );
     writeln!(
         out,
-        "const {} *cxxbridge01$rust_box${}$deref(const ::cxxbridge::Box<{}> *ptr) noexcept;",
+        "const {} *cxxbridge01$rust_box${}$deref(const ::rust::Box<{}> *ptr) noexcept;",
         inner, instance, inner,
     );
     writeln!(
         out,
-        "{} *cxxbridge01$rust_box${}$deref_mut(::cxxbridge::Box<{}> *ptr) noexcept;",
+        "{} *cxxbridge01$rust_box${}$deref_mut(::rust::Box<{}> *ptr) noexcept;",
         inner, instance, inner,
     );
     writeln!(out, "#endif // CXXBRIDGE01_RUST_BOX_{}", instance);
diff --git a/include/cxxbridge.h b/include/cxxbridge.h
index 2ff3d20..a668a66 100644
--- a/include/cxxbridge.h
+++ b/include/cxxbridge.h
@@ -4,10 +4,8 @@
 #include <iostream>
 #include <string>
 
-namespace cxxbridge01 {}
-namespace cxxbridge = cxxbridge01;
-
-namespace cxxbridge01 {
+namespace rust {
+inline namespace cxxbridge01 {
 
 class String final {
 public:
@@ -130,4 +128,5 @@ private:
 std::ostream &operator<<(std::ostream &os, const String &s);
 std::ostream &operator<<(std::ostream &os, const Str &s);
 
-} // namespace cxxbridge01
+} // inline namespace cxxbridge01
+} // namespace rust
diff --git a/src/cxxbridge.cc b/src/cxxbridge.cc
index da0b450..c139688 100644
--- a/src/cxxbridge.cc
+++ b/src/cxxbridge.cc
@@ -3,8 +3,6 @@
 #include <memory>
 #include <stdexcept>
 
-namespace cxxbridge = cxxbridge01;
-
 extern "C" {
 const char *cxxbridge01$cxx_string$data(const std::string &s) noexcept {
   return s.data();
@@ -14,22 +12,23 @@ size_t cxxbridge01$cxx_string$length(const std::string &s) noexcept {
   return s.length();
 }
 
-// cxxbridge::String
-void cxxbridge01$rust_string$new(cxxbridge::String *self) noexcept;
-void cxxbridge01$rust_string$clone(cxxbridge::String *self,
-                                   const cxxbridge::String &other) noexcept;
-bool cxxbridge01$rust_string$from(cxxbridge::String *self, const char *ptr,
+// rust::String
+void cxxbridge01$rust_string$new(rust::String *self) noexcept;
+void cxxbridge01$rust_string$clone(rust::String *self,
+                                   const rust::String &other) noexcept;
+bool cxxbridge01$rust_string$from(rust::String *self, const char *ptr,
                                   size_t len) noexcept;
-void cxxbridge01$rust_string$drop(cxxbridge::String *self) noexcept;
+void cxxbridge01$rust_string$drop(rust::String *self) noexcept;
 const char *
-cxxbridge01$rust_string$ptr(const cxxbridge::String *self) noexcept;
-size_t cxxbridge01$rust_string$len(const cxxbridge::String *self) noexcept;
+cxxbridge01$rust_string$ptr(const rust::String *self) noexcept;
+size_t cxxbridge01$rust_string$len(const rust::String *self) noexcept;
 
-// cxxbridge::Str
+// rust::Str
 bool cxxbridge01$rust_str$valid(const char *ptr, size_t len) noexcept;
 } // extern "C"
 
-namespace cxxbridge01 {
+namespace rust {
+inline namespace cxxbridge01 {
 
 String::String() noexcept { cxxbridge01$rust_string$new(this); }
 
@@ -45,7 +44,7 @@ String::String(String &&other) noexcept {
 String::String(const char *s) {
   auto len = strlen(s);
   if (!cxxbridge01$rust_string$from(this, s, len)) {
-    throw std::invalid_argument("data for cxxbridge::String is not utf-8");
+    throw std::invalid_argument("data for rust::String is not utf-8");
   }
 }
 
@@ -53,7 +52,7 @@ String::String(const std::string &s) {
   auto ptr = s.data();
   auto len = s.length();
   if (!cxxbridge01$rust_string$from(this, ptr, len)) {
-    throw std::invalid_argument("data for cxxbridge::String is not utf-8");
+    throw std::invalid_argument("data for rust::String is not utf-8");
   }
 }
 
@@ -102,13 +101,13 @@ Str::Str() noexcept
 
 Str::Str(const char *s) : repr(Repr{s, strlen(s)}) {
   if (!cxxbridge01$rust_str$valid(this->repr.ptr, this->repr.len)) {
-    throw std::invalid_argument("data for cxxbridge::Str is not utf-8");
+    throw std::invalid_argument("data for rust::Str is not utf-8");
   }
 }
 
 Str::Str(const std::string &s) : repr(Repr{s.data(), s.length()}) {
   if (!cxxbridge01$rust_str$valid(this->repr.ptr, this->repr.len)) {
-    throw std::invalid_argument("data for cxxbridge::Str is not utf-8");
+    throw std::invalid_argument("data for rust::Str is not utf-8");
   }
 }
 
@@ -138,7 +137,8 @@ std::ostream &operator<<(std::ostream &os, const Str &s) {
   return os;
 }
 
-} // namespace cxxbridge01
+} // inline namespace cxxbridge01
+} // namespace rust
 
 extern "C" {
 void cxxbridge01$unique_ptr$std$string$null(
diff --git a/src/lib.rs b/src/lib.rs
index abf7321..006159a 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -302,10 +302,10 @@
 //!
 //! <table>
 //! <tr><th>name in Rust</th><th>name in C++</th><th>restrictions</th></tr>
-//! <tr><td>String</td><td>cxxbridge::String</td><td></td></tr>
-//! <tr><td>&amp;str</td><td>cxxbridge::Str</td><td></td></tr>
+//! <tr><td>String</td><td>rust::String</td><td></td></tr>
+//! <tr><td>&amp;str</td><td>rust::Str</td><td></td></tr>
 //! <tr><td><a href="https://docs.rs/cxx/0.1/cxx/struct.CxxString.html">CxxString</a></td><td>std::string</td><td><sup><i>cannot be passed by value</i></sup></td></tr>
-//! <tr><td>Box&lt;T&gt;</td><td>cxxbridge::Box&lt;T&gt;</td><td><sup><i>cannot hold opaque C++ type</i></sup></td></tr>
+//! <tr><td>Box&lt;T&gt;</td><td>rust::Box&lt;T&gt;</td><td><sup><i>cannot hold opaque C++ type</i></sup></td></tr>
 //! <tr><td><a href="https://docs.rs/cxx/0.1/cxx/struct.UniquePtr.html">UniquePtr&lt;T&gt;</a></td><td>std::unique_ptr&lt;T&gt;</td><td><sup><i>cannot hold opaque Rust type</i></sup></td></tr>
 //! <tr><td></td><td></td><td></td></tr>
 //! </table>
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 5800f29..65640df 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -19,12 +19,12 @@ std::unique_ptr<C> c_return_unique_ptr() {
 
 const size_t &c_return_ref(const Shared &shared) { return shared.z; }
 
-cxxbridge::Str c_return_str(const Shared &shared) {
+rust::Str c_return_str(const Shared &shared) {
   (void)shared;
   return "2020";
 }
 
-cxxbridge::String c_return_rust_string() { return "2020"; }
+rust::String c_return_rust_string() { return "2020"; }
 
 std::unique_ptr<std::string> c_return_unique_ptr_string() {
   return std::unique_ptr<std::string>(new std::string("2020"));
@@ -42,7 +42,7 @@ void c_take_shared(Shared shared) {
   }
 }
 
-void c_take_box(cxxbridge::Box<R> r) {
+void c_take_box(rust::Box<R> r) {
   (void)r;
   cxx_test_suite_set_correct();
 }
@@ -61,13 +61,13 @@ void c_take_ref_c(const C &c) {
   }
 }
 
-void c_take_str(cxxbridge::Str s) {
+void c_take_str(rust::Str s) {
   if (std::string(s) == "2020") {
     cxx_test_suite_set_correct();
   }
 }
 
-void c_take_rust_string(cxxbridge::String s) {
+void c_take_rust_string(rust::String s) {
   if (std::string(s) == "2020") {
     cxx_test_suite_set_correct();
   }
@@ -99,8 +99,8 @@ extern "C" const char *cxx_run_test() noexcept {
   r_take_shared(Shared{2020});
   r_take_unique_ptr(std::unique_ptr<C>(new C{2020}));
   r_take_ref_c(C{2020});
-  r_take_str(cxxbridge::Str("2020"));
-  // TODO r_take_rust_string(cxxbridge::String("2020"));
+  r_take_str(rust::Str("2020"));
+  // TODO r_take_rust_string(rust::String("2020"));
   r_take_unique_ptr_string(
       std::unique_ptr<std::string>(new std::string("2020")));
 
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 3600eb6..f41cc5e 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -19,21 +19,21 @@ private:
 
 size_t c_return_primitive();
 Shared c_return_shared();
-cxxbridge::Box<R> c_return_box();
+rust::Box<R> c_return_box();
 std::unique_ptr<C> c_return_unique_ptr();
 const size_t &c_return_ref(const Shared &shared);
-cxxbridge::Str c_return_str(const Shared &shared);
-cxxbridge::String c_return_rust_string();
+rust::Str c_return_str(const Shared &shared);
+rust::String c_return_rust_string();
 std::unique_ptr<std::string> c_return_unique_ptr_string();
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);
-void c_take_box(cxxbridge::Box<R> r);
+void c_take_box(rust::Box<R> r);
 void c_take_unique_ptr(std::unique_ptr<C> c);
 void c_take_ref_r(const R &r);
 void c_take_ref_c(const C &c);
-void c_take_str(cxxbridge::Str s);
-void c_take_rust_string(cxxbridge::String s);
+void c_take_str(rust::Str s);
+void c_take_rust_string(rust::String s);
 void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 
 } // namespace tests

